儿童学Python(19):分外美学原理

一、什么是非凡

丰裕即是一个事件,该事件会在程序执行过程中发生,影响了先后的例行履行。
相似景观下,在Python无法正常处理程序时就会发生一个卓殊。
异常是Python对象,表示一个错误。
当Python脚本暴发分外时我们需要捕获处理它,否则程序会告一段落执行。

二、非常处理

捕捉非凡可以利用try…except语句。
try…except语句用来检测try语句块中的错误,从而让except语句捕获相当新闻并拍卖。
假定你不想在卓殊暴发时结束你的次第,只需在try里捕获它。

语法:
以下为简单的try….except…else的语法

try:
<语句>        #运行别的代码
except <名字>:
<语句>        #如果在try部份引发了'name'异常
except <名字>,<数据>:
<语句>        #如果引发了'name'异常,获得附加的数据
else:
<语句>        #如果没有异常发生

try的工作原理是,当开首一个try语句后,python就在近期程序的上下文中作标志,这样当非凡现身时就足以回来这里,try子句先举办,接下去会爆发哪些倚重于实践时是否出现非常。

假使当try后的说话执行时暴发卓殊,python就跳回到try并施行第一个门当户对该特其它except子句,分外处理完毕,控制流就透过全部try语句(除非在拍卖卓殊时又掀起新的不得了)。

万一在try后的讲话里发出了要命,却绝非匹配的except子句,万分将被递交到上层的try,或者到程序的最上层(这样将寿终正寝程序,并打印缺省的失误信息)。

假诺在try子句执行时没有发出非常,python将执行else语句后的话语(假使有else的话),然后决定流通过任何try语句。

例1

try:
    fh = open("mytest", "w")
    fh.write("This is a file to test exception!")
except IOError:
    print "Error: No file found or read file error!"
else:
    print "Write cotent to file succeed!"
fh.close()

运转结果:

This is a file to test exception!

翻开mytest文件中的内容:

This is a file to test exception

例2

将mytest文件的写权限去掉

chmod -w mytest

再度实施test.py,结果为

Error: 
Error: No file found or read file error!

三、使用except而不带任何特别类型

您可以不带任何特别类型使用except

try:
    正常的操作
   ......................
except:
    发生异常,执行这块代码
   ......................
else:
如果没有异常执行这块代码

上述措施try…except语句捕获所有发生的可怜。但这不是一个很好的法子,我们无法由此该程序识别出切实可行的不得了信息。因为它擒获所有的非凡。

四、try…except…finally语句

finally 中的代码无论是否暴发特别都将被执行

例3:除0异常

try:
    1 / 0
except Exception as e:
    print "0 can not be divided!"
else:
    print "No exception!"
finally:
    print "Anyway, statement in finally block will be executed!"

运作结果:

0 can not be divided!
Anyway, statement in finally block will be executed!

五、raise触发异常

例5

#define function
def test_func( level ):
    if level < 1:
        raise Exception("Invalid level!", level)

try:
    #invoke function
    test_func(0)                
except "any":
    print 1
else:
    print 2
finally:
    print 3

运行结果:

3
Traceback (most recent call last):
  File “test.py”, line 8, in <module>
test_func(0)
  File “test.py”, line 4, in test_func
raise Exception(“Invalid level!”, level)
Exception: (‘Invalid level!’,0)

从运行结果可以看到,raise抛出特别后,except和else中的语句都没有被打印出来,不过finally中的语句被打印出来了。